<?php
//$Id: drupal.php,v 1.4 2006/07/28 12:00:32 karens Exp $
/**
 * This file acts as an interface for Drupal into PhpGedView. 
 * 
 * The module checks to see if the user is defined to phpGedView. If so
 * it logs them on, if not it adds them as a user to the system.
 * 
 * This file belongs in the top level of the phpGedView folder. 
 * All other integration files belong in a modules/phpgedview 
 * directory in Drupal
 *
 */

global $users;
$_SESSION['EMBEDDED'] = TRUE;
require ("config.php");

if ($_REQUEST['path'] > '') {
  $path = $_REQUEST['path'];
} else {
  $path = 'index.php';
}

$path .= strstr($path, '?') ? '&' : '?';

$post_email = " ";
$post_user = "";
		
// create some variables in case they dont get in from the cookie
$def_canedit = "no";		
$def_canedit = "no";		
$def_theme = " ";
$def_rootid = "I1";
$def_verified = "yes";
$def_verified_by_admin = "no";
$def_contact_method = "messaging2";
$def_gedcom = "";
$def_language = "english";
$def_upass = "";
$def_create_user = "no";

// pick up cookie values
if (isset($_COOKIE['def_canedit'])) $def_canedit = $_COOKIE['def_canedit'];
if (isset($_COOKIE['def_canadmin'])) $def_canadmin = $_COOKIE['def_canadmin'];
if (isset($_COOKIE['def_theme'])) $def_theme = $_COOKIE['def_theme'];
if (isset($_COOKIE['def_rootid'])) $def_rootid = $_COOKIE['def_rootid'];
if (isset($_COOKIE['def_verified'])) $def_verified = $_COOKIE['def_verified'];
if (isset($_COOKIE['def_verified_by_admin'])) $def_verified_by_admin = $_COOKIE['def_verified_by_admin'];
if (isset($_COOKIE['def_contact_method'])) $def_contact_method = $_COOKIE['def_contact_method'];
if (isset($_COOKIE['def_gedcom'])) $def_gedcom = $_COOKIE['def_gedcom'];
if (isset($_COOKIE['def_language'])) $def_language = $_COOKIE['def_language'];
if (isset($_COOKIE['def_upass'])) $def_upass = $_COOKIE['def_upass'];
if (isset($_COOKIE['def_create_user'])) $def_create_user = $_COOKIE['def_create_user'];
		
if (isset($_COOKIE['post_user'])) $post_user = $_COOKIE['post_user'];
if (isset($_COOKIE['post_email'])) $post_email = $_COOKIE['post_email'];

if (!empty($post_user)) {
  // need to add the user into gedview - but only if def_create_user says its ok
  if (!getUser($post_user) and ($def_create_user == "yes") ) {
    $newuser = array();
    $newuser["username"] = $post_user;
    $newuser["firstname"] = $post_firstname;
    $newuser["lastname"] = $post_lastname;
    $newuser["canedit"] = array();
    if ($def_canedit == "yes") {
      $newuser["canedit"][$def_gedcom] = "yes";
    } else {
      $newuser["canedit"][$def_gedcom] = "";
    }
    $newuser["gedcomid"] = array();
    $newuser["gedcomid"][$def_gedcom] = '';
    $newuser["rootid"] = array();
    $newuser["rootid"][$def_gedcom] = $def_rootid;
    $newuser["canadmin"] = $def_canadmin;
    $newuser["email"] = $post_email;
    $newuser["verified"] = "yes";
    $newuser["verified_by_admin"] = $def_verified_by_admin;
    $newuser["pwrequested"] = "";
    $newuser["theme"] = $def_theme;
    $newuser["language"] = $def_language;
    $newuser["reg_timestamp"] = date("U");
    $newuser["reg_hashcode"] = "";
    $newuser["loggedin"] = "N";
    $newuser["sessiontime"] = 0;
    $newuser["contactmethod"] = $def_contact_method;
    $newuser["password"] = crypt($def_upass);
    addUser($newuser, "added");	
  }
  $my_user = getUser($post_user);
  $admin_ver = $my_user["verified_by_admin"] ;
			
  // is the user there and verified ?
  if (getUser($post_user) and ($admin_ver == "yes")) {
    $sql = "UPDATE ".$TBLPREFIX."users SET u_loggedin='Y', u_sessiontime='".time()."' WHERE u_username='$post_user'";
    $res = dbquery($sql);
    AddToLog("Drupal Login Successful ->" . $post_user ."<-");
    $_SESSION['pgv_user'] = $post_user;
    $url = $path . session_name() ."=". session_id();
    $url.="&command=gedcom";
  } else {
    $url = $path ."logout=1";
  }
} else {
  $url = $path ."logout=1";
}

// session may have been reset, reset this value, too
$_SESSION['EMBEDDED'] = TRUE;

header("Location: $url");
exit;

